﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;

namespace EditColumnInGridGroupingControl {
    public partial class Form1 : Form {
        public Form1() {
            InitializeComponent();
            SetGridStyle();
        }

        private void SetGridStyle() {
            gridGroupingControl1.TableOptions.GridVisualStyles = GridVisualStyles.Office2007Blue;
            gridGroupingControl1.TopLevelGroupOptions.ShowCaption = false;
            gridGroupingControl1.TableDescriptor.AllowEdit = false;
            gridGroupingControl1.TableDescriptor.AllowNew = false;
            gridGroupingControl1.ShowGroupDropArea = false;
            gridGroupingControl1.TopLevelGroupOptions.ShowCaption = false;
            gridGroupingControl1.TableOptions.AllowSelection = GridSelectionFlags.Any | GridSelectionFlags.Row;
            gridGroupingControl1.TableOptions.ListBoxSelectionCurrentCellOptions = GridListBoxSelectionCurrentCellOptions.MoveCurrentCellWithMouse;
            gridGroupingControl1.TableOptions.ListBoxSelectionMode = SelectionMode.One;
            gridGroupingControl1.TableOptions.SelectionBackColor = Color.Red;
            
            
          //  this.gridGroupingControl1.TableControlCurrentCellEditingComplete += new GridTableControlEventHandler(gridGroupingControl1_TableControlCurrentCellEditingComplete);
        }           

        void gridGroupingControl1_TableControlCurrentCellEditingComplete(object sender, GridTableControlEventArgs e)
        {
            GridCurrentCell cc = this.gridGroupingControl1.TableControl.CurrentCell;
            MessageBox.Show("Row "+cc.RowIndex.ToString()+", Column" +cc.ColIndex.ToString());
        }

        private void BindGrid() {
            List<Student> students = new List<Student> { 
                new Student{ ID=1, Name="stu1", Address="NewYork1"},
                new Student{ ID=2, Name="stu2", Address="NewYork2"},
                new Student{ ID=3, Name="stu3", Address="NewYork3"},
            };
            gridGroupingControl1.DataSource = students;
            gridGroupingControl1.TableDescriptor.Columns["ID"].HeaderText = "ID";
            gridGroupingControl1.TableDescriptor.Columns["ID"].Width = 80;
            gridGroupingControl1.TableDescriptor.Columns["Name"].HeaderText = "Name";
            gridGroupingControl1.TableDescriptor.Columns["Name"].Width = 100;
            gridGroupingControl1.TableDescriptor.Columns["Address"].HeaderText = "Address";
            gridGroupingControl1.TableDescriptor.Columns["Address"].Width = 160;
        }

        public class Student {
            public int ID { get; set; }
            public string Name { get; set; }
            public string Address { get; set; }
        }

        private void Load_Grid_Data_Click(object sender, EventArgs e) {
            BindGrid();
        }

        private void Edit_Grid_Click(object sender, EventArgs e) {
            gridGroupingControl1.TableDescriptor.AllowEdit = true;
            gridGroupingControl1.Table.TableDescriptor.Columns[0].ReadOnly = true;
            gridGroupingControl1.Table.TableDescriptor.Columns[1].ReadOnly = true;
            gridGroupingControl1.Table.TableDescriptor.Columns["Address"].Appearance.AnyCell.BackColor = Color.Yellow;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            this.gridGroupingControl1.TableControl.Selections.Clear();
            this.gridGroupingControl1.Refresh();
        }

    }
}
